/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * A lightweight description of an [Order](#type-order) that is returned when &#x60;returned_entries&#x60; is true on a [SearchOrderRequest](#type-searchorderrequest)
 */
@ApiModel(description = "A lightweight description of an [Order](#type-order) that is returned when `returned_entries` is true on a [SearchOrderRequest](#type-searchorderrequest)")

public class OrderEntry {
  @JsonProperty("order_id")
  private String orderId = null;

  @JsonProperty("location_id")
  private String locationId = null;

  public OrderEntry orderId(String orderId) {
    this.orderId = orderId;
    return this;
  }

   /**
   * The id of the Order
   * @return orderId
  **/
  @ApiModelProperty(value = "The id of the Order")
  public String getOrderId() {
    return orderId;
  }

  public void setOrderId(String orderId) {
    this.orderId = orderId;
  }

  public OrderEntry locationId(String locationId) {
    this.locationId = locationId;
    return this;
  }

   /**
   * The location id the Order belongs to.
   * @return locationId
  **/
  @ApiModelProperty(value = "The location id the Order belongs to.")
  public String getLocationId() {
    return locationId;
  }

  public void setLocationId(String locationId) {
    this.locationId = locationId;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    OrderEntry orderEntry = (OrderEntry) o;
    return Objects.equals(this.orderId, orderEntry.orderId) &&
        Objects.equals(this.locationId, orderEntry.locationId);
  }

  @Override
  public int hashCode() {
    return Objects.hash(orderId, locationId);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class OrderEntry {\n");
    
    sb.append("    orderId: ").append(toIndentedString(orderId)).append("\n");
    sb.append("    locationId: ").append(toIndentedString(locationId)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

