/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.Money;
import com.squareup.connect.models.OrderQuantityUnit;
import com.squareup.connect.models.OrderReturnDiscount;
import com.squareup.connect.models.OrderReturnLineItemModifier;
import com.squareup.connect.models.OrderReturnTax;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;

/**
 * The line item being returned in an Order.
 */
@ApiModel(description = "The line item being returned in an Order.")

public class OrderReturnLineItem {
  @JsonProperty("uid")
  private String uid = null;

  @JsonProperty("source_line_item_uid")
  private String sourceLineItemUid = null;

  @JsonProperty("name")
  private String name = null;

  @JsonProperty("quantity")
  private String quantity = null;

  @JsonProperty("quantity_unit")
  private OrderQuantityUnit quantityUnit = null;

  @JsonProperty("note")
  private String note = null;

  @JsonProperty("catalog_object_id")
  private String catalogObjectId = null;

  @JsonProperty("variation_name")
  private String variationName = null;

  @JsonProperty("return_modifiers")
  private List<OrderReturnLineItemModifier> returnModifiers = new ArrayList<OrderReturnLineItemModifier>();

  @JsonProperty("return_taxes")
  private List<OrderReturnTax> returnTaxes = new ArrayList<OrderReturnTax>();

  @JsonProperty("return_discounts")
  private List<OrderReturnDiscount> returnDiscounts = new ArrayList<OrderReturnDiscount>();

  @JsonProperty("base_price_money")
  private Money basePriceMoney = null;

  @JsonProperty("variation_total_price_money")
  private Money variationTotalPriceMoney = null;

  @JsonProperty("gross_return_money")
  private Money grossReturnMoney = null;

  @JsonProperty("total_tax_money")
  private Money totalTaxMoney = null;

  @JsonProperty("total_discount_money")
  private Money totalDiscountMoney = null;

  @JsonProperty("total_money")
  private Money totalMoney = null;

  public OrderReturnLineItem uid(String uid) {
    this.uid = uid;
    return this;
  }

   /**
   * Unique identifier for this return line item entry. This is a read-only field.
   * @return uid
  **/
  @ApiModelProperty(value = "Unique identifier for this return line item entry. This is a read-only field.")
  public String getUid() {
    return uid;
  }

  public void setUid(String uid) {
    this.uid = uid;
  }

  public OrderReturnLineItem sourceLineItemUid(String sourceLineItemUid) {
    this.sourceLineItemUid = sourceLineItemUid;
    return this;
  }

   /**
   * `uid` of the LineItem in the original sale Order.
   * @return sourceLineItemUid
  **/
  @ApiModelProperty(value = "`uid` of the LineItem in the original sale Order.")
  public String getSourceLineItemUid() {
    return sourceLineItemUid;
  }

  public void setSourceLineItemUid(String sourceLineItemUid) {
    this.sourceLineItemUid = sourceLineItemUid;
  }

  public OrderReturnLineItem name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The name of the line item.
   * @return name
  **/
  @ApiModelProperty(value = "The name of the line item.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public OrderReturnLineItem quantity(String quantity) {
    this.quantity = quantity;
    return this;
  }

   /**
   * The quantity returned, formatted as a decimal number. For example: `\"3\"`.  Line items with a `quantity_unit` can have non-integer quantities. For example: `\"1.70000\"`.
   * @return quantity
  **/
  @ApiModelProperty(required = true, value = "The quantity returned, formatted as a decimal number. For example: `\"3\"`.  Line items with a `quantity_unit` can have non-integer quantities. For example: `\"1.70000\"`.")
  public String getQuantity() {
    return quantity;
  }

  public void setQuantity(String quantity) {
    this.quantity = quantity;
  }

  public OrderReturnLineItem quantityUnit(OrderQuantityUnit quantityUnit) {
    this.quantityUnit = quantityUnit;
    return this;
  }

   /**
   * The unit and precision that this return line item's quantity is measured in.
   * @return quantityUnit
  **/
  @ApiModelProperty(value = "The unit and precision that this return line item's quantity is measured in.")
  public OrderQuantityUnit getQuantityUnit() {
    return quantityUnit;
  }

  public void setQuantityUnit(OrderQuantityUnit quantityUnit) {
    this.quantityUnit = quantityUnit;
  }

  public OrderReturnLineItem note(String note) {
    this.note = note;
    return this;
  }

   /**
   * The note of the returned line item.
   * @return note
  **/
  @ApiModelProperty(value = "The note of the returned line item.")
  public String getNote() {
    return note;
  }

  public void setNote(String note) {
    this.note = note;
  }

  public OrderReturnLineItem catalogObjectId(String catalogObjectId) {
    this.catalogObjectId = catalogObjectId;
    return this;
  }

   /**
   * The [CatalogItemVariation](#type-catalogitemvariation) id applied to this returned line item.
   * @return catalogObjectId
  **/
  @ApiModelProperty(value = "The [CatalogItemVariation](#type-catalogitemvariation) id applied to this returned line item.")
  public String getCatalogObjectId() {
    return catalogObjectId;
  }

  public void setCatalogObjectId(String catalogObjectId) {
    this.catalogObjectId = catalogObjectId;
  }

  public OrderReturnLineItem variationName(String variationName) {
    this.variationName = variationName;
    return this;
  }

   /**
   * The name of the variation applied to this returned line item.
   * @return variationName
  **/
  @ApiModelProperty(value = "The name of the variation applied to this returned line item.")
  public String getVariationName() {
    return variationName;
  }

  public void setVariationName(String variationName) {
    this.variationName = variationName;
  }

  public OrderReturnLineItem returnModifiers(List<OrderReturnLineItemModifier> returnModifiers) {
    this.returnModifiers = returnModifiers;
    return this;
  }

  public OrderReturnLineItem addReturnModifiersItem(OrderReturnLineItemModifier returnModifiersItem) {
    this.returnModifiers.add(returnModifiersItem);
    return this;
  }

   /**
   * The [CatalogModifier](#type-catalogmodifier)s applied to this line item.
   * @return returnModifiers
  **/
  @ApiModelProperty(value = "The [CatalogModifier](#type-catalogmodifier)s applied to this line item.")
  public List<OrderReturnLineItemModifier> getReturnModifiers() {
    return returnModifiers;
  }

  public void setReturnModifiers(List<OrderReturnLineItemModifier> returnModifiers) {
    this.returnModifiers = returnModifiers;
  }

  public OrderReturnLineItem returnTaxes(List<OrderReturnTax> returnTaxes) {
    this.returnTaxes = returnTaxes;
    return this;
  }

  public OrderReturnLineItem addReturnTaxesItem(OrderReturnTax returnTaxesItem) {
    this.returnTaxes.add(returnTaxesItem);
    return this;
  }

   /**
   * A list of taxes applied to this line item. On read or retrieve, this list includes both item-level taxes and any return-level taxes apportioned to this item.
   * @return returnTaxes
  **/
  @ApiModelProperty(value = "A list of taxes applied to this line item. On read or retrieve, this list includes both item-level taxes and any return-level taxes apportioned to this item.")
  public List<OrderReturnTax> getReturnTaxes() {
    return returnTaxes;
  }

  public void setReturnTaxes(List<OrderReturnTax> returnTaxes) {
    this.returnTaxes = returnTaxes;
  }

  public OrderReturnLineItem returnDiscounts(List<OrderReturnDiscount> returnDiscounts) {
    this.returnDiscounts = returnDiscounts;
    return this;
  }

  public OrderReturnLineItem addReturnDiscountsItem(OrderReturnDiscount returnDiscountsItem) {
    this.returnDiscounts.add(returnDiscountsItem);
    return this;
  }

   /**
   * A list of discounts applied to this line item. On read or retrieve, this list includes both item-level discounts and any return-level discounts apportioned to this item.
   * @return returnDiscounts
  **/
  @ApiModelProperty(value = "A list of discounts applied to this line item. On read or retrieve, this list includes both item-level discounts and any return-level discounts apportioned to this item.")
  public List<OrderReturnDiscount> getReturnDiscounts() {
    return returnDiscounts;
  }

  public void setReturnDiscounts(List<OrderReturnDiscount> returnDiscounts) {
    this.returnDiscounts = returnDiscounts;
  }

  public OrderReturnLineItem basePriceMoney(Money basePriceMoney) {
    this.basePriceMoney = basePriceMoney;
    return this;
  }

   /**
   * The base price for a single unit of the line item.
   * @return basePriceMoney
  **/
  @ApiModelProperty(value = "The base price for a single unit of the line item.")
  public Money getBasePriceMoney() {
    return basePriceMoney;
  }

  public void setBasePriceMoney(Money basePriceMoney) {
    this.basePriceMoney = basePriceMoney;
  }

  public OrderReturnLineItem variationTotalPriceMoney(Money variationTotalPriceMoney) {
    this.variationTotalPriceMoney = variationTotalPriceMoney;
    return this;
  }

   /**
   * The total price of all item variations returned in this line item. Calculated as `base_price_money` multiplied by `quantity`. Does not include modifiers.
   * @return variationTotalPriceMoney
  **/
  @ApiModelProperty(value = "The total price of all item variations returned in this line item. Calculated as `base_price_money` multiplied by `quantity`. Does not include modifiers.")
  public Money getVariationTotalPriceMoney() {
    return variationTotalPriceMoney;
  }

  public void setVariationTotalPriceMoney(Money variationTotalPriceMoney) {
    this.variationTotalPriceMoney = variationTotalPriceMoney;
  }

  public OrderReturnLineItem grossReturnMoney(Money grossReturnMoney) {
    this.grossReturnMoney = grossReturnMoney;
    return this;
  }

   /**
   * The gross return amount of money calculated as (item base price + modifiers price) * quantity.
   * @return grossReturnMoney
  **/
  @ApiModelProperty(value = "The gross return amount of money calculated as (item base price + modifiers price) * quantity.")
  public Money getGrossReturnMoney() {
    return grossReturnMoney;
  }

  public void setGrossReturnMoney(Money grossReturnMoney) {
    this.grossReturnMoney = grossReturnMoney;
  }

  public OrderReturnLineItem totalTaxMoney(Money totalTaxMoney) {
    this.totalTaxMoney = totalTaxMoney;
    return this;
  }

   /**
   * The total tax amount of money to return for the line item.
   * @return totalTaxMoney
  **/
  @ApiModelProperty(value = "The total tax amount of money to return for the line item.")
  public Money getTotalTaxMoney() {
    return totalTaxMoney;
  }

  public void setTotalTaxMoney(Money totalTaxMoney) {
    this.totalTaxMoney = totalTaxMoney;
  }

  public OrderReturnLineItem totalDiscountMoney(Money totalDiscountMoney) {
    this.totalDiscountMoney = totalDiscountMoney;
    return this;
  }

   /**
   * The total discount amount of money to return for the line item.
   * @return totalDiscountMoney
  **/
  @ApiModelProperty(value = "The total discount amount of money to return for the line item.")
  public Money getTotalDiscountMoney() {
    return totalDiscountMoney;
  }

  public void setTotalDiscountMoney(Money totalDiscountMoney) {
    this.totalDiscountMoney = totalDiscountMoney;
  }

  public OrderReturnLineItem totalMoney(Money totalMoney) {
    this.totalMoney = totalMoney;
    return this;
  }

   /**
   * The total amount of money to return for this line item.
   * @return totalMoney
  **/
  @ApiModelProperty(value = "The total amount of money to return for this line item.")
  public Money getTotalMoney() {
    return totalMoney;
  }

  public void setTotalMoney(Money totalMoney) {
    this.totalMoney = totalMoney;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    OrderReturnLineItem orderReturnLineItem = (OrderReturnLineItem) o;
    return Objects.equals(this.uid, orderReturnLineItem.uid) &&
        Objects.equals(this.sourceLineItemUid, orderReturnLineItem.sourceLineItemUid) &&
        Objects.equals(this.name, orderReturnLineItem.name) &&
        Objects.equals(this.quantity, orderReturnLineItem.quantity) &&
        Objects.equals(this.quantityUnit, orderReturnLineItem.quantityUnit) &&
        Objects.equals(this.note, orderReturnLineItem.note) &&
        Objects.equals(this.catalogObjectId, orderReturnLineItem.catalogObjectId) &&
        Objects.equals(this.variationName, orderReturnLineItem.variationName) &&
        Objects.equals(this.returnModifiers, orderReturnLineItem.returnModifiers) &&
        Objects.equals(this.returnTaxes, orderReturnLineItem.returnTaxes) &&
        Objects.equals(this.returnDiscounts, orderReturnLineItem.returnDiscounts) &&
        Objects.equals(this.basePriceMoney, orderReturnLineItem.basePriceMoney) &&
        Objects.equals(this.variationTotalPriceMoney, orderReturnLineItem.variationTotalPriceMoney) &&
        Objects.equals(this.grossReturnMoney, orderReturnLineItem.grossReturnMoney) &&
        Objects.equals(this.totalTaxMoney, orderReturnLineItem.totalTaxMoney) &&
        Objects.equals(this.totalDiscountMoney, orderReturnLineItem.totalDiscountMoney) &&
        Objects.equals(this.totalMoney, orderReturnLineItem.totalMoney);
  }

  @Override
  public int hashCode() {
    return Objects.hash(uid, sourceLineItemUid, name, quantity, quantityUnit, note, catalogObjectId, variationName, returnModifiers, returnTaxes, returnDiscounts, basePriceMoney, variationTotalPriceMoney, grossReturnMoney, totalTaxMoney, totalDiscountMoney, totalMoney);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class OrderReturnLineItem {\n");
    
    sb.append("    uid: ").append(toIndentedString(uid)).append("\n");
    sb.append("    sourceLineItemUid: ").append(toIndentedString(sourceLineItemUid)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    quantity: ").append(toIndentedString(quantity)).append("\n");
    sb.append("    quantityUnit: ").append(toIndentedString(quantityUnit)).append("\n");
    sb.append("    note: ").append(toIndentedString(note)).append("\n");
    sb.append("    catalogObjectId: ").append(toIndentedString(catalogObjectId)).append("\n");
    sb.append("    variationName: ").append(toIndentedString(variationName)).append("\n");
    sb.append("    returnModifiers: ").append(toIndentedString(returnModifiers)).append("\n");
    sb.append("    returnTaxes: ").append(toIndentedString(returnTaxes)).append("\n");
    sb.append("    returnDiscounts: ").append(toIndentedString(returnDiscounts)).append("\n");
    sb.append("    basePriceMoney: ").append(toIndentedString(basePriceMoney)).append("\n");
    sb.append("    variationTotalPriceMoney: ").append(toIndentedString(variationTotalPriceMoney)).append("\n");
    sb.append("    grossReturnMoney: ").append(toIndentedString(grossReturnMoney)).append("\n");
    sb.append("    totalTaxMoney: ").append(toIndentedString(totalTaxMoney)).append("\n");
    sb.append("    totalDiscountMoney: ").append(toIndentedString(totalDiscountMoney)).append("\n");
    sb.append("    totalMoney: ").append(toIndentedString(totalMoney)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

