/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.ShiftFilter;
import com.squareup.connect.models.ShiftSort;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * The parameters of a &#x60;Shift&#x60; search query. Includes filter and sort options.
 */
@ApiModel(description = "The parameters of a `Shift` search query. Includes filter and sort options.")

public class ShiftQuery {
  @JsonProperty("filter")
  private ShiftFilter filter = null;

  @JsonProperty("sort")
  private ShiftSort sort = null;

  public ShiftQuery filter(ShiftFilter filter) {
    this.filter = filter;
    return this;
  }

   /**
   * Query filter options
   * @return filter
  **/
  @ApiModelProperty(value = "Query filter options")
  public ShiftFilter getFilter() {
    return filter;
  }

  public void setFilter(ShiftFilter filter) {
    this.filter = filter;
  }

  public ShiftQuery sort(ShiftSort sort) {
    this.sort = sort;
    return this;
  }

   /**
   * Sort order details
   * @return sort
  **/
  @ApiModelProperty(value = "Sort order details")
  public ShiftSort getSort() {
    return sort;
  }

  public void setSort(ShiftSort sort) {
    this.sort = sort;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ShiftQuery shiftQuery = (ShiftQuery) o;
    return Objects.equals(this.filter, shiftQuery.filter) &&
        Objects.equals(this.sort, shiftQuery.sort);
  }

  @Override
  public int hashCode() {
    return Objects.hash(filter, sort);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ShiftQuery {\n");
    
    sb.append("    filter: ").append(toIndentedString(filter)).append("\n");
    sb.append("    sort: ").append(toIndentedString(sort)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

